#!/usr/bin/env python
from __future__ import generators
# import findrox; findrox.version(1,9,12)
# it uses a patched version of ROX-Lib2 in rox/
import rox
from rox import applet, g, Menu, InfoWin, tasks, ButtonMixed, choices, options
from rox.Menu import Menu, set_save_name
from Options import *

from rox import app_options
"""
_options_box = None

v = 0

def open_menu(widget, event, position_menu):
	menu.popup(widget, event, position_menu)
"""
class menu(gobject.GObject, Menu):
	def __init__(self, Options, Window):
		gobject.GObject.__init__(self)
		self.__Options = Options
		set_save_name(self.__Options.program)
		Menu.__init__(self, 'main', [
	        ('/Quit',		'quit',		'<StockItem>',  '', g.STOCK_QUIT),
	 	('/Help',          	'help',         '<StockItem>',  '', g.STOCK_HELP),
	        ('/Info',          	'info',         '<StockItem>',  '', g.STOCK_DIALOG_INFO),
	        ('/Show Window',        'show_window',  '<StockItem>',  '', g.STOCK_INDEX),
		('/Options',            'show_options', '<StockItem>',  '', g.STOCK_PREFERENCES),
		('/Refresh',            'refresh_ticker', '<StockItem>',  '', g.STOCK_REFRESH),
	        ('/Next Msg',            'update_ticker', '<StockItem>',  '', g.STOCK_GO_FORWARD)
	        ])
		self.attach(Window, self)
	def quit(self): self.emit("m_quit")
	def help(self): self.emit("m_help")
	def info(self): self.emit("m_info")
	def show_window(self): self.emit("m_show_window")
	def show_options(self): self.emit("m_show_options")
	def refresh_ticker(self): self.emit("m_refresh_ticker")
	def update_ticker(self): self.emit("m_update_ticker")
	#def help(self):
		#Help = g.Window()
		#HelpTab = Help_Container()
		#Help.add(HelpTab)
		#Help.show()

gobject.signal_new("m_quit", menu, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("m_help", menu, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("m_info", menu, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("m_show_window", menu, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("m_show_options", menu, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("m_refresh_ticker", menu, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("m_update_ticker", menu, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
"""
def info():
        InfoWin.infowin(" " + Version + " ")

def help():
	Help = g.Window()
	HelpTab = Help_Container()
	Help.add(HelpTab)
	Help.show()

def show_options():
	tasks.Task(edit_options())
	#rox.edit_options()
	
def edit_options(options_file = None):
#	assert app_options

	yield None
	global _options_box
	if _options_box:
		_options_box.present()
		return
	
	if not options_file:
		options_file = os.path.join(rox.app_dir, 'Options.xml')
	
	_options_box = OptionsBox(app_options, options_file)

	def closed(widget):
		global _options_box
		assert _options_box == widget
		_options_box = None
	_options_box.connect('destroy', closed)
	_options_box.open()

"""
